<?php
    /*
    ** SnortCenter Copyright (C) 2001,2002,2003 Stefan Dens
    **
    ** Author: Stefan Dens <larc@pandora.be>
    **
    ** This program is free software; you can redistribute it and/or modify
    ** it under the terms of the GNU General Public License as published by
    ** the Free Software Foundation; either version 2 of the License, or
    ** (at your option) any later version.
    **
    ** This program is distributed in the hope that it will be useful,
        ** but WITHOUT ANY WARRANTY; without even the implied warranty of
    ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ** GNU General Public License for more details.
    **
    ** You should have received a copy of the GNU General Public License
    ** along with this program; if not, write to the Free Software
    ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
    */
?>
<?php
    include("config.php");
     
    $db = NewACIDDBConnection($DBlib_path, $DBtype);
    $db->acidConnect($DB_dbname, $DB_host, $DB_port, $DB_user, $DB_password);
     

     
    if ($spp_name == "http_decode:") {
        $spp_value = $ports . ' ' . $unicode . ' ' . $iis_alt_unicode . ' ' . $double_encode . ' ' . $iis_flip_slash . ' ' . $full_whitespace;
    }
    elseif ($spp_name == "rpc_decode:") {
        $spp_value = $ports;
    }
    elseif (($spp_name == "telnet_decode:") || ($spp_name == "telnet_decode")) {
        $spp_value = $ports;
        if (!$ports) {
            $spp_name = 'telnet_decode';
        } else {
            $spp_name = 'telnet_decode:';
        }
    }
    elseif ($spp_name == "asn1_decode:") {
        $spp_value = '';
    }
    elseif ($spp_name == "bo:") {
        $spp_value = $nobrute . ' ' . $bo_key;
    }
    elseif (($spp_name == "frag2:") || ($spp_name == "frag2")) {
        $spp_value = '';
        if ($timeout) {
            $spp_value = 'timeout ' . $timeout . ', ';
        }
        if ($memcap) {
            $spp_value  .= 'memcap ' . $memcap . ', ';
        }
        if ($min_ttl) {
            $spp_value  .= 'min_ttl ' . $min_ttl . ', ';
        }
        if ($ttl_limit) {
            $spp_value  .= 'ttl_limit ' . $ttl_limit . ', ';
        }
        if ($spp_value == '') {
            $spp_name = 'frag2';
        } else {
            $spp_name = 'frag2:';
            $spp_value = substr(rtrim($spp_value), 0, -1);
        } // strip last ","
    }
    elseif (($spp_name == "stream4:") || ($spp_name == "stream4")) {
        $spp_value = '';
        if ($detect_scans) {
            $spp_value = 'detect_scans, ';
        }
        if ($detect_state_problems) {
            $spp_value  .= 'detect_state_problems, ';
        }
        if ($disable_evasion_alerts) {
            $spp_value  .= 'disable_evasion_alerts, ';
        }
        if ($keepstats) {
            $spp_value  .= 'keepstats ' . $keepstats . ', ';
        }
        if ($noinspect) {
            $spp_value  .= 'noinspect, ';
        }
        if ($timeout) {
            $spp_value  .= 'timeout ' . $timeout . ', ';
        }
        if ($memcap) {
            $spp_value  .= 'memcap ' . $memcap . ', ';
        }
        if ($min_ttl) {
            $spp_value  .= 'min_ttl ' . $min_ttl . ', ';
        }
        if ($ttl_limit) {
            $spp_value  .= 'ttl_limit ' . $ttl_limit . ', ';
        }
        if ($log_flushed_streams) {
            $spp_value  .= 'log_flushed_streams, ';
        }
         
        if ($spp_value == '') {
            $spp_name = 'stream4';
        } else {
            $spp_name = 'stream4:';
            $spp_value = substr(rtrim($spp_value), 0, -1);
        } // strip last ","
    }
    elseif (($spp_name == "stream4_reassemble:") || ($spp_name == "stream4_reassemble")) {
        $spp_value = '';
        if ($both) {
            $spp_value  .= 'both, ';
        }
        elseif ($clientonly) {
            $spp_value  .= 'clientonly, ';
        }
        elseif ($serveronly) {
            $spp_value  .= 'serveronly, ';
        }
        if ($noalerts) {
            $spp_value  .= 'noalerts, ';
        }
        if ($ports) {
            $spp_value  .= 'ports ' . $ports . ', ';
        }
         
        if ($spp_value == '') {
            $spp_name = 'stream4_reassemble';
        } else {
            $spp_name = 'stream4_reassemble:';
            $spp_value = substr(rtrim($spp_value), 0, -1);
        } // strip last ","
    }
    elseif ($spp_name == "portscan:") {
        $spp_value = '';
        if ($do  != 'Select') {
            if (!$network) {
                $network = 'any';
            }
            if (!$nr_ports) {
                $nr_ports = '4';
            }
            if (!$period) {
                $period = '3';
            }
            if (!$path) {
                $path = 'portscan.log';
            }
            $spp_value = "$network $nr_ports $period $path";
        }
    }
    elseif ($spp_name == "portscan-ignorehosts:") {
        $spp_value = $hosts;
    }
    elseif (($spp_name == "conversation:") || ($spp_name == "conversation")) {
        $spp_value = '';
        if ($allowed_ip_protocols) {
            $spp_value = 'allowed_ip_protocols ' . $allowed_ip_protocols . ', ';
        }
        if ($timeout) {
            $spp_value  .= 'timeout ' . $timeout . ', ';
        }
        if ($max_conversations) {
            $spp_value  .= 'max_conversations ' . $max_conversations . ', ';
        }
        if ($alert_odd_protocols) {
            $spp_value  .= 'alert_odd_protocols, ';
        }
         
        if ($spp_value == '') {
            $spp_name = 'conversation';
        } else {
            $spp_name = 'conversation:';
            $spp_value = substr(rtrim($spp_value), 0, -1);
        } // strip last ","
    }
    elseif (($spp_name == "portscan2:") || ($spp_name == "portscan2")) {
        $spp_value = '';
        if ($scanners_max) {
            $spp_value = 'scanners_max ' . $scanners_max . ', ';
        }
        if ($targets_max) {
            $spp_value  .= 'targets_max ' . $targets_max . ', ';
        }
        if ($target_limit) {
            $spp_value  .= 'target_limit ' . $target_limit . ', ';
        }
        if ($port_limit) {
            $spp_value  .= 'port_limit ' . $port_limit . ', ';
        }
        if ($timeout) {
            $spp_value  .= 'timeout ' . $timeout . ', ';
        }
        if ($log) {
            $spp_value  .= 'log ' . $log . ', ';
        }
         
        if ($spp_value == '') {
            $spp_name = 'portscan2';
        } else {
            $spp_name = 'portscan2:';
            $spp_value = substr(rtrim($spp_value), 0, -1);
        } // strip last ","
    }
    elseif ($spp_name == "portscan2-ignorehosts:") {
        $spp_value = $hosts;
    }
     
     
    if (($do == "Duplicate") || ($do == "Save")) {
        $result = $db->acidExecute("INSERT INTO preprocessor (spp_name, spp_value) VALUES ('$spp_name', '$spp_value')");
        $result = $db->acidExecute("SELECT max(id) FROM preprocessor");
        $myrow = $result->acidFetchRow();
        $result->acidFreeRows();
        $id = $myrow[0];
	echo '<SCRIPT language=javascript>setTimeout("location.href=\'spp.php?sensor_id='.$sensor_id.'\'",0);</SCRIPT>';
    }
     
    if ($do == "Update") {
        $result = $db->acidExecute("UPDATE preprocessor SET spp_name='$spp_name', spp_value='$spp_value' where id='$id'");
        $result->acidFreeRows();
	echo '<SCRIPT language=javascript>setTimeout("location.href=\'spp.php?sensor_id='.$sensor_id.'\'",0);</SCRIPT>';
    }
     
    if (($spp  != "new") && ($do  != 'Select')) {
        $result = $db->acidExecute("SELECT id, spp_name, spp_value  FROM preprocessor where id='$id'");
        $myrow = $result->acidFetchRow();
        $result->acidFreeRows();
        list($id, $spp_name, $spp_value) = $myrow;
    }
    include('top.inc.php');
    echo "<BR>";
    echo "<FORM method=GET>";
     
    if ($spp_name == "http_decode:") {
        if (strpos($spp_value, "iis_alt_unicode")  !== false) {
            $iis_alt_unicode_select = 'CHECKED';
            $spp_value = str_replace("iis_alt_unicode", '', $spp_value);
        }
        if (strpos($spp_value, "unicode")  !== false) {
            $unicode_select = 'CHECKED';
            $spp_value = str_replace("unicode", '', $spp_value);
        }
        if (strpos($spp_value, "double_encode")  !== false) {
            $double_encode_select = 'CHECKED';
            $spp_value = str_replace("double_encode", '', $spp_value);
        }
        if (strpos($spp_value, "iis_flip_slash")  !== false) {
            $iis_flip_slash_select = 'CHECKED';
            $spp_value = str_replace("iis_flip_slash", '', $spp_value);
        }
        if (strpos($spp_value, "full_whitespace")  !== false) {
            $full_whitespace_select = 'CHECKED';
            $spp_value = str_replace("full_whitespace", '', $spp_value);
        }
        $ports = trim($spp_value);
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=50%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>HTTP Decode:</B> $lang[128]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[129]</TD><TD><INPUT NAME=ports TYPE=TEXT value='$ports' size='60'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[131]</TD><TD><INPUT NAME=unicode TYPE=CHECKBOX value='unicode' $unicode_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[250]</TD><TD><INPUT NAME=iis_alt_unicode TYPE=CHECKBOX value='iis_alt_unicode' $iis_alt_unicode_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[251]</TD><TD><INPUT NAME=double_encode TYPE=CHECKBOX value='double_encode' $double_encode_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[252]</TD><TD><INPUT NAME=iis_flip_slash TYPE=CHECKBOX value='iis_flip_slash' $iis_flip_slash_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[253]</TD><TD><INPUT NAME=full_whitespace TYPE=CHECKBOX value='full_whitespace' $full_whitespace_select></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif ($spp_name == "rpc_decode:") {
        $ports = trim($spp_value);
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=50%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>RPC Decode:</B> $lang[133]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[134]</TD><TD><INPUT NAME=ports TYPE=TEXT value='$ports' size='60'></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif (($spp_name == "bo:") || ($spp_name == "bo")) {
        if (strpos($spp_value, "-nobrute")  !== false) {
            $nobrute_select = 'CHECKED';
            $spp_value = str_replace("-nobrute", '', $spp_value);
        }
        $bo_key = trim($spp_value);
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=40%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>BO:</B> $lang[135]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[136]</TD><TD><INPUT NAME=bo_key TYPE=TEXT value='$bo_key' size='10'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[137]</TD><TD><INPUT NAME=nobrute TYPE=CHECKBOX value='-nobrute' $nobrute_select></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif (($spp_name == "frag2:") || ($spp_name == "frag2")) {
        $foo = explode(',', trim($spp_value));
        foreach($foo as $i) {
            if (strpos($i, "timeout")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $timeout = trim($foo1[1]);
            }
            if (strpos($i, "memcap")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $memcap = trim($foo1[1]);
            }
            if (strpos($i, "min_ttl")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $min_ttl = trim($foo1[1]);
            }
            if (strpos($i, "ttl_limit")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $ttl_limit = trim($foo1[1]);
            }
        }
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=30%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>Frag2:</B> $lang[138]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[139]</TD><TD><INPUT NAME=timeout TYPE=TEXT value='$timeout' size='15'> (sec)</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[140]</TD><TD><INPUT NAME=memcap TYPE=TEXT value='$memcap' size='15'> (bytes <16000)</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[248]</TD><TD><INPUT NAME=min_ttl TYPE=TEXT value='$min_ttl' size='15'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[249]</TD><TD><INPUT NAME=ttl_limit TYPE=TEXT value='$ttl_limit' size='15'></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif (($spp_name == "stream4:") || ($spp_name == "stream4")) {
        $foo = explode(',', trim($spp_value));
        foreach($foo as $i) {
            if (strpos($i, "detect_scans")  !== false) {
                $detect_scans_select = 'CHECKED';
            }
            if (strpos($i, "detect_state_problems")  !== false) {
                $detect_state_problems_select = 'CHECKED';
            }
            if (strpos($i, "disable_evasion_alerts")  !== false) {
                $disable_evasion_alerts_select = 'CHECKED';
            }
            if (strpos($i, "keepstats")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $keepstats = trim($foo1[1]);
            }
            if (strpos($i, "noinspect")  !== false) {
                $noinspect_select = 'CHECKED';
            }
            if (strpos($i, "timeout")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $timeout = trim($foo1[1]);
            }
            if (strpos($i, "memcap")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $memcap = trim($foo1[1]);
            }
            if (strpos($i, "min_ttl")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $min_ttl = trim($foo1[1]);
            }
            if (strpos($i, "ttl_limit")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $ttl_limit = trim($foo1[1]);
            }
            if (strpos($i, "log_flushed_streams")  !== false) {
                $log_flushed_streams_select = 'CHECKED';
            }
        }
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=50%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>Stream4:</B> $lang[141]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[142]</TD><TD><INPUT NAME=detect_scans TYPE=CHECKBOX value='detect_scans' $detect_scans_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[143]</TD><TD><INPUT NAME=detect_state_problems TYPE=CHECKBOX value='detect_state_problems' $detect_state_problems_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[144]</TD><TD><INPUT NAME=disable_evasion_alerts TYPE=CHECKBOX value='disable_evasion_alerts' $disable_evasion_alerts_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[145]</TD><TD><INPUT NAME=noinspect TYPE=CHECKBOX value='noinspect' $noinspect_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[146]</TD><TD><INPUT NAME=log_flushed_streams TYPE=CHECKBOX value='log_flushed_streams' $log_flushed_streams_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[147]</TD><TD><INPUT NAME=keepstats TYPE=TEXT value='$keepstats' size='15'> [machine | binary]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[139]</TD><TD><INPUT NAME=timeout TYPE=TEXT value='$timeout' size='15'> (sec)</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[140]</TD><TD><INPUT NAME=memcap TYPE=TEXT value='$memcap' size='15'> (bytes <16000)</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[248]</TD><TD><INPUT NAME=min_ttl TYPE=TEXT value='$min_ttl' size='15'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[249]</TD><TD><INPUT NAME=ttl_limit TYPE=TEXT value='$ttl_limit' size='15'></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif (($spp_name == "stream4_reassemble:") || ($spp_name == "stream4_reassemble")) {
        $foo = explode(',', trim($spp_value));
        foreach($foo as $i) {
            if (strpos($i, "clientonly")  !== false) {
                $clientonly_select = 'CHECKED';
            }
            if (strpos($i, "serveronly")  !== false) {
                $serveronly_select = 'CHECKED';
            }
            if (strpos($i, "both")  !== false) {
                $both_select = 'CHECKED';
            }
            if (strpos($i, "noalerts")  !== false) {
                $noalerts_select = 'CHECKED';
            }
             
            if (strpos($i, "ports")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $ports = trim($foo1[1]);
            }
        }
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=55%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>Stream4_reassemble:</B> $lang[148]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[149]</TD><TD><INPUT NAME=clientonly TYPE=CHECKBOX value='clientonly' $clientonly_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[150]</TD><TD><INPUT NAME=serveronly TYPE=CHECKBOX value='serveronly' $serveronly_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[151]</TD><TD><INPUT NAME=both TYPE=CHECKBOX value='both' $both_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[152]</TD><TD><INPUT NAME=noalerts TYPE=CHECKBOX value='noalerts' $noalerts_select></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[129]</TD><TD><INPUT NAME=ports TYPE=TEXT value='$ports' size='25'> [21 23 80 | all | default]</TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif ($spp_name == "portscan:") {
        list($network, $nr_ports, $period, $path) = explode(' ', trim($spp_value));
         
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=55%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>Portscan:</B> $lang[153]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[154]</TD><TD><INPUT NAME=network TYPE=TEXT value='$network' size='45'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[155]</TD><TD><INPUT NAME=nr_ports TYPE=TEXT value='$nr_ports' size='5'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[156]</TD><TD><INPUT NAME=period TYPE=TEXT value='$period' size='5'> (sec)</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[157]</TD><TD><INPUT NAME=path TYPE=TEXT value='$path' size='45'></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif ($spp_name == "portscan-ignorehosts:") {
        $hosts = trim($spp_value);
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=60%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>Portscan-ignorehosts:</B> $lang[158]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[159]</TD><TD><INPUT NAME=hosts TYPE=TEXT value='$hosts' size='75'></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif (($spp_name == "telnet_decode") || ($spp_name == "telnet_decode:")) {
        $ports = trim($spp_value);
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=50%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>$spp_name</B> $lang[164]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>Port List</TD><TD><INPUT NAME=ports TYPE=TEXT value='$ports' size='60'></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif (($spp_name == "conversation:") || ($spp_name == "conversation")) {
        $foo = explode(',', trim($spp_value));
        foreach($foo as $i) {
            if (strpos($i, "allowed_ip_protocols")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $allowed_ip_protocols = trim($foo1[1]);
            }
            if (strpos($i, "timeout")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $timeout = trim($foo1[1]);
            }
            if (strpos($i, "max_conversations")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $max_conversations = trim($foo1[1]);
            }
            if (strpos($i, "alert_odd_protocols")  !== false) {
                $alert_odd_protocols_select = 'CHECKED';
            }
        }
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=50%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>Conversation:</B> $lang[254]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[255]</TD><TD><INPUT NAME=allowed_ip_protocols TYPE=TEXT value='$allowed_ip_protocols' size='15'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[139]</TD><TD><INPUT NAME=timeout TYPE=TEXT value='$timeout' size='15'> (sec)</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[256]</TD><TD><INPUT NAME=max_conversations TYPE=TEXT value='$max_conversations' size='15'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[257]</TD><TD><INPUT NAME=alert_odd_protocols TYPE=CHECKBOX value='alert_odd_protocols' $alert_odd_protocols_select></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif (($spp_name == "portscan2:") || ($spp_name == "portscan2")) {
        $foo = explode(',', trim($spp_value));
        foreach($foo as $i) {
            if (strpos($i, "scanners_max")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $scanners_max = trim($foo1[1]);
            }
            if (strpos($i, "targets_max")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $targets_max = trim($foo1[1]);
            }
            if (strpos($i, "target_limit")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $target_limit = trim($foo1[1]);
            }
            if (strpos($i, "port_limit")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $port_limit = trim($foo1[1]);
            }
            if (strpos($i, "timeout")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $timeout = trim($foo1[1]);
            }
            if (strpos($i, "log")  !== false) {
                $foo1 = explode(' ', trim($i), 2);
                $log = trim($foo1[1]);
            }
        }
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=50%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>Portscan2:</B> $lang[258]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[259]</TD><TD><INPUT NAME=scanners_max TYPE=TEXT value='$scanners_max' size='15'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[260]</TD><TD><INPUT NAME=targets_max TYPE=TEXT value='$targets_max' size='15'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[261]</TD><TD><INPUT NAME=target_limit TYPE=TEXT value='$target_limit' size='15'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[262]</TD><TD><INPUT NAME=port_limit TYPE=TEXT value='$port_limit' size='15'></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[139]</TD><TD><INPUT NAME=timeout TYPE=TEXT value='$timeout' size='15'> (sec)</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[263]</TD><TD><INPUT NAME=log TYPE=TEXT value='$log' size='15'> (log directory)</TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif ($spp_name == "portscan2-ignorehosts:") {
        $hosts = trim($spp_value);
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=60%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>Portscan2-ignorehosts:</B> $lang[158]</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left>$lang[159]</TD><TD><INPUT NAME=hosts TYPE=TEXT value='$hosts' size='75'></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
    elseif ($spp_name == "asn1_decode") {
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=40%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>$spp_name</B></TD></TR>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<TR bgcolor=#DDDDDD><TD>&nbsp;</TD></TR><TR bgcolor=#DDDDDD><TD align=center>$lang[160]</TD></TR><TR bgcolor=#DDDDDD><TD>&nbsp;</TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
     
    elseif ($spp  != "new") {
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<INPUT TYPE=HIDDEN NAME='spp_name' VALUE='$spp_name'>";
        echo "<INPUT TYPE=HIDDEN name=id value=$id>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=60%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=left colspan=2><B>$lang[161]:</B> $lang[162] !!!</TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD align=left><INPUT NAME=spp_name TYPE=TEXT value='$spp_name'></TD><TD><INPUT NAME=spp_value TYPE=TEXT value='$spp_value' size='75'></TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
    }
     
    if ($do == 'Select') {
        echo "<CENTER><INPUT NAME='do' VALUE='Save' TYPE=SUBMIT>&nbsp;<INPUT VALUE='Reset' TYPE=RESET></CENTER>";
    }
    elseif (($spp  != "new") && ($spp_name  != "asn1_decode")) {
        echo "<CENTER><INPUT NAME='do' VALUE='Update' TYPE=SUBMIT>&nbsp;<INPUT NAME='do' VALUE='Duplicate' TYPE=SUBMIT>&nbsp;<INPUT VALUE='Reset' TYPE=RESET></CENTER>";
    }
    elseif ($spp == "new") {
        echo "<INPUT TYPE=HIDDEN NAME='sensor_id' VALUE='$sensor_id'>";
        echo "<table align=center border=0 cellspacing=0 cellpadding=0 width=40%><tr>";
        # -------- Begin left table --------------
        echo "<TD width=48% valign=top>";
        echo "<table align=center border=0 cellpadding=1 cellspacing=0 width=100%><tr bgcolor=#f9f890><td>";
        echo "<table style=\"font-size:12px; font-family: Verdana;\" align=center border=0 cellspacing=0 cellpadding=0 width=100%>";
         
        echo "<TR><TD align=center colspan=2><B>$lang[163]</B></TD></TR>";
        echo "<TR bgcolor=#DDDDDD><TD>&nbsp;</TD></TR><TR bgcolor=#DDDDDD><TD align=center>
            <SELECT name=spp_name>
            <OPTION value='bo:'>BO ($lang[135])</OPTION>
            <OPTION value='frag2:'>Frag2 ($lang[138])</OPTION>
            <OPTION value='http_decode:'>HTTP_Decode ($lang[128])</OPTION>
	    <OPTION value='portscan:'>PortScan ($lang[153])</OPTION>
            <OPTION value='portscan-ignorehosts:'>Portscan-ignorehosts ($lang[158])</OPTION>
            <OPTION value='rpc_decode:'>RPC Decode ($lang[133])</OPTION>
            <OPTION value='stream4'>Stream4 ($lang[141])</OPTION>
            <OPTION value='stream4_reassemble'>Stream4 Reassemble ($lang[148])</OPTION>
            <OPTION value='telnet_decode:'>Telnet Decode ($lang[164])</OPTION>
            <OPTION value='asn1_decode'>ASN1 Decode</OPTION>
            <OPTION value='conversation:'>Conversation ($lang[254])</OPTION>
            <OPTION value='portscan2:'>PortScan2 ($lang[258])</OPTION>
            <OPTION value='portscan2-ignorehosts:'>Portscan2-ignorehosts ($lang[158])</OPTION>
            <OPTION value=''>-----------------------------------------------</OPTION>
            <OPTION value=''>$lang[165] $snortcenter_ver</OPTION>
            </SELECT>
            </TD></TR><TR bgcolor=#DDDDDD><TD>&nbsp;</TD></TR>";
        echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><BR>";
        echo "<CENTER><INPUT NAME='do' VALUE='Select' TYPE=SUBMIT></CENTER>";
    }
     
    echo "</FORM>";
    echo "<BR>";
    require('bottom.inc.php');
?>
